<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="report">
<html>
<head>
  <title>Report</title>
</head>
<body bgcolor="white">
  <xsl:apply-templates select="viewInfo"/>
  <xsl:apply-templates select="categories"/>
</body>
</html>
</xsl:template>


<xsl:template match="viewInfo">
    <h1><xsl:apply-templates select="viewName"/></h1>
    <p><b><xsl:apply-templates select="viewTitle"/></b><br/>
      <xsl:apply-templates select="viewComments"/>
    </p>

    <p>Generated by <xsl:value-of select="/report/author"/> on
        <xsl:value-of select="/report/created/@month"/>/ 
        <xsl:value-of select="/report/created/@day"/>/ 
        <xsl:value-of select="/report/created/@year"/>.
    </p>
</xsl:template>

<xsl:template match="viewName">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="viewTitle">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="viewComments">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="categories">
    <xsl:for-each select="category">
           <xsl:apply-templates select="catName"/>
           <xsl:apply-templates select="catComments"/>
	   <xsl:choose>
		   <xsl:when test='nodeCount>0'>
			   <xsl:apply-templates select="catSections"/>
		   </xsl:when>
		   <xsl:otherwise>
			   <h4>There are no nodes experiencing outages</h4>
		   </xsl:otherwise>
	   </xsl:choose>
    </xsl:for-each>
</xsl:template>

<xsl:template match="catName">
        <hr/><h2><xsl:value-of select="."/></h2>
</xsl:template>

<xsl:template match="catTitle">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="catComments">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="catSections">
        <xsl:apply-templates select="section"/>
</xsl:template>

<xsl:template match="section">
        <h3><xsl:apply-templates select="sectionTitle"/></h3>
        <p><xsl:apply-templates select="sectionDescr"/></p>
        <table border="1">
          <xsl:apply-templates select="col"/>
          <xsl:apply-templates select="rows"/>
        </table>
</xsl:template>

<xsl:template match="sectionName">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="sectionTitle">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="sectionDescr">
        <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="col">
        <tr>
                <xsl:apply-templates select="colTitle"/>
        </tr>
</xsl:template>

<xsl:template match="colTitle">
       <th><xsl:value-of select="."/></th>
</xsl:template>

<xsl:template match="rows">
        <xsl:apply-templates select="row"/>
</xsl:template>

<xsl:template match="row">
        <tr>
          <xsl:apply-templates select="value"/>
        </tr>
</xsl:template>

<xsl:template match="value">
        <xsl:if test="@type='data'">
          <td align="right"><xsl:value-of select="."/></td>
        </xsl:if>
        <xsl:if test="@type='title'">
          <td><xsl:value-of select="."/></td>
        </xsl:if>
        <xsl:if test="@type='other'">
          <td align="right"><xsl:value-of select="."/></td>
        </xsl:if>
</xsl:template>

</xsl:stylesheet>
